<?php

$bannersObj = new Banners();

class Banners {

var $mDb; 
var $mConfig; 

function __construct() {
	global $Config; 
	$this -> mDb = new iplus(); 
	$this -> mConfig = $Config; 
}

function convert_object_to_array($data) {

    if (is_object($data)) {
        $data = get_object_vars($data);
    }

    if (is_array($data)) {
        return array_map(__METHOD__, $data);
    }
    else {
        return $data;
    }
}

function getSomeBanners($aStart, $aLimit, $sort, $type, $searchName) {
// echo "TEST2";die();
	$sql = "SELECT b.`id`,";
	$sql .= " b.`title`,";
    $sql .= " b.`date_added`,";
    $sql .= " b.`status`,";
    $sql .= " b.`img`,";
    $sql .= " b.`url`,";
    $sql .= " u.`full_name` AS 'user_full_name', ";
    $sql .= " fl.`name` AS 'feature_name', ";
    $sql .= " pl.`title` AS 'page_name'";
    $sql .= " FROM `banners` b ";
	$sql .= " LEFT JOIN `users` u ON u.`id` = b.`added_by` ";
	$sql .= " LEFT JOIN `features_langs` fl  ON b.`feature_id` = fl.`features_id`  AND fl.lang_code = 'ar'";
	$sql .= " LEFT JOIN `pages_langs` pl  ON b.`page_id` = pl.`page_id`  AND pl.lang_code = 'ar'";
	$sql .= " WHERE b.`id` > 0  ";
// 	$sql .= " AND fl.lang_code = 'ar'";
    $sql .= $searchName ? ' AND b.`title` like "%'.$searchName.'%"' : '';
	$sql .= $sort === 'sort' ? " ORDER BY b.`sort` {$type}" : " ORDER BY b.{$sort} {$type}";
	$sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

// 	 echo $sql; die();

	return $this -> mDb -> getAll($sql); 
}

function getSearchBannersCount($sort, $type, $searchName) {
	$sql = "SELECT COUNT(b.`id`) as 'result_count' FROM `banners` b";
	$sql .= " WHERE b.`id` > 0 ";
    $sql .= $searchName ? ' AND b.`title` like "%'.$searchName.'%"' : '';
	$sql .= $sort === 'sort' ? " ORDER BY b.`sort` {$type}" : " ORDER BY b.{$sort} {$type}";

	//echo $sql; die();

	return $this -> mDb -> getOne($sql); 
}

function getBannersCount() {
	$sql = "SELECT COUNT(`id`) as 'count' FROM `banners` ";
	return $this -> mDb -> getOne($sql); 
}

function addEditBanner($request, $img, $img_en, $banner_id) {
    // print_r($request);die();
    $dataLangObj = json_decode($request['countryLangObj']);
    $newDataLangObj = $this->convert_object_to_array($dataLangObj);
      $sort=$request['sort']?$request['sort']:0;
    $url=$request['BannerUrl']?$request['BannerUrl']:"";
    unset($request['action']);
    unset($request['langs']);

    $res = false; 

    if ($banner_id === '' && $request['operation'] === 'add')
    {
        // Add
        unset($request['operation']);
        $dateTime = date('Y-m-d H:i:s');

        $sql = "INSERT INTO `banners` SET ";
        $sql .= " `added_by` = '{$request['added_by']}',";
        $sql .= " `title` = '{$request['title']}',";
        $sql .= $request['type'] === 'feature'?" `feature_id` = '{$request['feature_id']}'," : " `page_id` = '{$request['page_id']}',";
        $sql .= " `type` = '{$request['type']}', ";
        $sql .= " `sort` = '{$sort}',";
        $sql .= " `url` = '{$url}',";
        $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
        $sql .= " `date_added` = '{$dateTime}',";
        $sql .= " `img` = '{$img}', ";
        $sql .= " `img_en` = '{$img_en}'";
        
        // echo $sql; die();
        $res = $this -> mDb ->query($sql);

            return $res;
    }
    else
    {

        // Edit

        $check_query = "SELECT `id` FROM `banners` WHERE `id` = '{$banner_id}'";
        // echo $check_query;die();
        $check_result = $this -> mDb -> getOne($check_query);

        if ($check_result === false) {
            
            return 403;

        }
        else{
                
            $sql = "UPDATE `banners` SET ";
            $sql .= " `added_by` = '{$request['added_by']}', ";
            $sql .= " `title` = '{$request['title']}', ";
             $sql .= $request['type'] === 'feature'?" `feature_id` = '{$request['feature_id']}', `page_id` = null, " : " `page_id` = '{$request['page_id']}', `feature_id` = null, ";
            $sql .= " `type` = '{$request['type']}', ";
            $sql .= " `sort` = '{$sort}',";
            $sql .= " `url` = '{$url}',";
            $sql .= $request['status'] === 'true' ? " `status` = '1' " : " `status` = '0'";

            if ($img != '' || $img != null) {

                // Delete old image from the server
                $img_query = "SELECT `img` FROM `banners` WHERE `id` = '{$banner_id}'";
                $img_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'banners/' . $img_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
                    $sql .= ",`img`='{$img}' ";    
                
                
            }
            if ($img_en != '' || $img_en != null) {

                // Delete old image from the server
                $img_query = "SELECT `img_en` FROM `banners` WHERE `id` = '{$banner_id}'";
                $img_en_result = $this -> mDb -> getOne($img_query);

                $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'banners/' . $img_en_result;

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }

                $sql .= ",`img_en`='{$img_en}' ";
            }

            $sql .= " WHERE `id` = '{$banner_id}'";

            // echo $sql;die();

           $res = $this -> mDb -> query($sql);
            
                return $res !== false;

        } 
    }

}

function getOneBanner($id) {

    $result = array();

    $sql = "SELECT b.`id`, b.`title`, b.`feature_id`, b.`added_by`, b.`status`,b.`url`, b.`img`, b.`img_en`,b.`sort`, f.parent_id as mainFeature, type, page_id FROM `banners` b left join `features` f ON b.feature_id = f.id";
    $sql .= " WHERE b.`id` = '{$id}'";
    // echo $sql;die();
    $result = $this -> mDb -> getRow($sql); 

    return $result;

}
function getPartnerByParentID($id) {
    $result = array();
    $sql = "SELECT c.`id`, cl.`name`, cl.`description` FROM `banners` c";
    $sql .= " LEFT JOIN `banners_langs` cl ON c.`id` = cl.`banner_id` ";
    $sql .= " WHERE c.`parent_id` = '{$id}' and cl.`lang_code`='ar' ";
//    echo $sql;
    $result = $this -> mDb -> getAll($sql);
    return $result;

}



function deleteBanner($ids) {

    $tempids='('.implode(',',$ids).')';

    $sql = "SELECT `img` FROM `banners`";
    $sql .= " WHERE `id` IN ".$tempids;
    $images = $this -> mDb -> getAll($sql);


    $catsql = "DELETE FROM `banners` ";
    $catsql.= " WHERE `id` IN ".$tempids;

    if($this-> mDb-> query($catsql)){

        if(count($images)>0){
            for ($i=0;$i<count($images);$i++){
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'banners/'. $images[$i]['img'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
        }
        return true;
    }
    else{
        return false;
    }
}






}
?>