<?php

$NewsWebObj = new Feature();

class Feature {

    var $mDb; 
    var $mConfig; 
    var $mMailer;

    function __construct() {
        global $Config; 
        $this->mDb = new iplus(); 
        $this->mConfig = $Config; 
        $this->mMailer = new Mailer();

    }



    //Get All Sub Features
    function convert_object_to_array($data) {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }
        
        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            // echo "test"; die();
            return $data;
        }
    }

    function getAllfeatures($start,$aItemsPerPage,$lang_code, $searchName, $type, $sort, $id) {
        
        $result=array();
        
        $sql = "select f.*,mf.name as parent_name,";
        $sql .= " fl.name, fl.description,";
        $sql .= " u.full_name as user_full_name";
        $sql .= " from features f";
        $sql .= " LEFT JOIN features_langs fl ON fl.features_id = f.id and fl.`lang_code`='{$lang_code}'";
        $sql .= " LEFT JOIN features_langs mf ON mf.features_id = f.parent_id and mf.`lang_code`='{$lang_code}'";
        $sql.= " LEFT JOIN users u ON f.added_by = u.id ";
        $sql.= " where f.id > 0 ";
        $sql.= $id? "AND parent_id = '{$id}'":"";
        $sql .= $searchName ? ' AND fl.`name` like "%'.$searchName.'%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY f.`sort` {$type}" : " ORDER BY fl.{$sort} {$type}";
        $sql.= "  LIMIT $start,$aItemsPerPage ";

        // echo  $sql;die();
        $result=$this -> mDb -> getAll($sql);

        return $result;
    } 

    //Get All Main Features 
    function getMainFeatures($aStart, $aLimit, $sort, $lang, $type, $searchName){

        $sql = "select fl.name, fl.description,";
        $sql .= " f.*";
        $sql .= " from features f";
        $sql .= " left join features_langs fl";
        $sql .= " ON f.id = fl.features_id  AND fl.lang_code = '{$lang}'";
        $sql .= " where f.parent_id = 0";
        $sql .= $searchName ? ' AND cl.`name` like "%'.$searchName.'%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY fl.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die;
        $res = $this -> mDb -> getAll($sql);
        return $res;
    }

    // Get Features With Subfeatures
    function getFeaturesWithSubFeatures($aStart, $aLimit, $sort, $lang, $type, $searchName){
        $sql  = "select f.*,";
        $sql .= " fl.name, fl.description ";
        $sql .= "from features f ";
        $sql .= "join features_langs fl ON f.id = fl.features_id ";
        $sql .= "WHERE fl.lang_code = '{$lang}'";
        $sql .= $searchName ? ' AND cl.`name` like "%'.$searchName.'%"' : '';
        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY fl.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql;die();
        $res=$this -> mDb -> getAll($sql);

        foreach($res as $row){
            if($row['parent_id'] == 0){
                foreach($res as $row2){
                    if($row['id'] == $row2['parent_id']){
                        $data[$row['id']]["id"] = $row['id']; 
                        $data[$row['id']]["name"] = $row['name']; 
                        $data[$row['id']]["description"] = $row['description']; 
                        $data[$row['id']]["image"] = $row['img']; 
                        $data[$row['id']]["icon"] = $row['icon']; 
                        $data[$row['id']]["subfeatures"] [] = $row2; 
                    }
                }
            }
        }
        return $data;
    }

    // Get One Feature With details
    function getOneFeaturesDetails($id,$lang_code) {

        $res=array();
        $sql  = "SELECT f.*,";
        $sql .= " mfl.name as parent_name,";
        $sql .= " fl.name, fl.description, fl.lang_code";
        $sql .= " from features f";
        $sql .= " LEFT JOIN features_langs fl ON f.id = fl.features_id";
        $sql .= " LEFT JOIN features_langs mfl ON f.parent_id = mfl.features_id AND fl.lang_code = mfl.lang_code";
        $sql.= " where f.`id` ='{$id}' ";

        //   echo $sql;die();
        $res=$this -> mDb -> getAll($sql);

        return $res;
    }

    //Add Or Edit Features
    function addEditFeature($request, $img, $icon, $img_en, $icon_en, $feature_id) {
        // echo $img;die();

        $categoryLangObj = json_decode($request['langs']);
        $newcategoryLangObj = $this->convert_object_to_array($categoryLangObj);
        // unset($request['action']);
        // unset($request['categoryLangObj']);
        $res = false; 
    
        if($request['parent_id'] == "undefined"){

            $parent_id = 0 ;
        }else {
            $parent_id = $request['parent_id'];
        }
        if (!$feature_id || $feature_id == "null" || $feature_id == null)
        {
            // Add
            unset($request['operation']);
            $dateTime = date('Y-m-d H:i:s');
            
            $sql = "INSERT INTO `features` SET "; 
            $sql .= " `added_by` = '{$request['user_id']}',"; 
            $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',"; 
            $sql .= " `date_added` = '{$dateTime}',";
            $sql .= " `sort` = '{$request['sort']}',"; 
            $sql .=  " `parent_id` = '{$request['parent_id']}',";
            $sql .= " `img` = '{$img}'";
            $sql .= ", `img_en` = '{$img_en}'";
            $sql .= $icon?", `icon` = '{$icon}'":'';
            $sql .= $icon_en?", `icon_en` = '{$icon_en}'":'';
            // echo $sql; die();
            $this -> mDb ->query($sql);
    
    
            $last_category_id = $this -> mDb ->getLastInsertId();
            // print_r($last_category_id);die();
            foreach ($newcategoryLangObj as $key => $value) {
                // $value['description'] = strip_tags($value['description']);
                $stmt = "INSERT INTO `features_langs`(`features_id`, `lang_code`, `name`, `description`,`date_added`) ";
                $stmt .=" VALUES ('{$last_category_id}', '{$value['lang_code']}', '{$value['name']}', '{$value['description']}', '{$dateTime}')";
                // echo $stmt;die();
                $res = $this -> mDb -> query($stmt);

            }
    
                return $res !== false;
    
        }
        else
        {
    
            // echo "Edit";die();
            // Edit
            
            $check_query = "SELECT `id` FROM `features` WHERE `id` = '{$feature_id}'";
            $check_result = $this -> mDb -> getOne($check_query);
            
            if ($check_result === false) {
                
                return "edit";
    
            }
            else{
                    
                $sql = "UPDATE `features` SET "; 
                $sql .= " `added_by` = '{$request['user_id']}', ";
                $sql .= " `sort` = '{$request['sort']}', ";
                $sql .= " `parent_id` = '{$request['parent_id']}',";
                $sql .= $request['status'] === 'true' ? " `status` = '1'" : " `status` = '0'";
    
                if ($img != '' || $img != null) {
    
                    // Delete old image from the server
                    $img_query = "SELECT `img` FROM `features` WHERE `id` = '{$feature_id}'";
                    $img_result = $this -> mDb -> getOne($img_query);
    
                    $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'features/' . $img_result;
    
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
    
                    $sql .= ",`img`='{$img}' ";
                }
    
                if ($icon != '' || $icon != null) {
    
                    // Delete old image from the server
                    $icon_query = "SELECT `icon` FROM `features` WHERE `id` = '{$feature_id}'";
                    // echo $icon_query;die();
                    $icon_result = $this -> mDb -> getOne($icon_query);
    
                    $old_icon = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'features/' . $icon_result;
                    if (file_exists($old_icon)) {
                        // echo $old_icon; die();
                        @unlink($old_icon);
                    }
    
                    $sql .= ",`icon`='{$icon}' ";
                }
    
                $sql .= " WHERE `id` = '{$feature_id}'";
    
                
                // return $sql; die();
                $this -> mDb -> query($sql);
    
                foreach ($newcategoryLangObj as $key => $value) {
                     $value['description'] = str_replace("'", "\'",$value['description']);
                    $stmt = "UPDATE `features_langs` SET";
                    $stmt .=" `name`='{$value['name']}', ";
                    $stmt .=" `description`='{$value['description']}' ";
                    $stmt .=" WHERE `lang_code`='{$value['lang_code']}' AND `features_id` = '{$feature_id}'";
                    
                    $res = $this -> mDb -> query($stmt);
                    
                }
    
                // return $stmt;die();
                return $res !== false;
    
            } 
        }
    
    }      

    //Delete Featur
    function deleteFeature($id) {
        $tempids='('.implode(',',$id).')';
            $sql = "SELECT `img`, `icon` FROM `features`";
            $sql .= " WHERE `id` IN ".$tempids;
            $images = $this -> mDb -> getAll($sql);
            // print_r($images[0]["img"]);die();
            $sqll = "DELETE FROM `features_langs` ";
            $sqll.= " WHERE `features_id` IN ".$tempids;
        
            $this-> mDb-> query($sqll);
        
            $featureql = "DELETE FROM `features` ";
            $featureql.= " WHERE `id` IN ".$tempids;
            if($this-> mDb-> query($featureql)){
        
                if(count($images)>0){
                    for ($i=0;$i<count($images);$i++){
                        $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'features/'. $images[$i]['img'];
                        $old_icon = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'features/'. $images[$i]['icon'];
                        if (file_exists($old_img)) {
                            @unlink($old_img);
                            @unlink($old_icon);
                        }
                    }
                }
                return true;
            }
            else{
                return false;
            }
        }







    
    
    
    
    
    
    
    
    
    
    
        //old

    
    
    
    
    
        function getOneFeature($id, $lang){
        $sql = "SELECT f.id as feature_id,";
        $sql .= " f.img as feature_img,";
        $sql .= "fl.name as feature_name, ";
        $sql .= "fl.description as feature_description ";
        $sql .= "from features f ";
        $sql .= "LEFT JOIN features_langs fl ON fl.news_id = f.id AND f.id = {$id} ";
        $sql .= "WHERE  fl.lang_code = '{$lang}'";

        // echo $sql; die();
        $data = $this -> mDb -> getAll($sql);
        foreach($data as $row){
            $arr[$row['lang_code']][] = $row;
        }
        return $data;
    }


    //getSearchFeaturesCount
    function getSearchFeaturesCount($sort, $type, $searchName, $id) {
        $sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `features` c";
        $sql .= " LEFT JOIN `features_langs` cl ON c.`id` = cl.`features_id` ";
        $sql .= " WHERE c.`id` > 0 AND cl.`lang_code` = 'ar'";
        $sql.= $id? "AND parent_id = '{$id}'":"";
        $sql .= $searchName ? ' AND cl.`name` like "%'.$searchName.'%"' : '';

        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY cl.{$sort} {$type}";

        //echo $sql; die();

        return $this -> mDb -> getOne($sql);
    }
    
    function getSubFeatures($id){
        // echo $id;die();
        $sql = "SELECT f.id, fl.name FROM `features` f LEFT JOIN `features_langs` fl ON f.id = fl.features_id where f.parent_id = '{$id}'  AND fl.lang_code = 'ar'";
        // echo $sql;die();
        $result = $this -> mDb -> getAll($sql);
        return $result;
    }

// getFeaturesCount
    function getFeaturesCount() {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `features`";
        return $this -> mDb -> getOne($sql);
    }

    
    function getTrainingCategories() {
        $result = array();
        $sql = "SELECT c.`id`, cl.`name`, cl.`description` FROM `categories` c";
        $sql .= " LEFT JOIN `categories_langs` cl ON c.`id` = cl.`category_id` ";
        $sql .= " WHERE  cl.`lang_code`='ar' and c.`category_type`='feature'";
   echo $sql;
        $result = $this -> mDb -> getAll($sql);
        return $result;
    }

    
    function getOneTrainingCourses($id) {

        $result = array();

        $sql = "SELECT `id`, `added_by`, `status`, `category_id`, `sort`, `img` FROM `news`";
        $sql .= " WHERE `id` = '{$id}'";
        $result = $this -> mDb -> getRow($sql);

        $stmt = "SELECT cl.`lang_code`, cl.`name`, cl.`description` FROM `news_langs` cl";
        $stmt .= " WHERE cl.`news_id` = '{$id}'";
        $result['langs'] = $this -> mDb -> getAll($stmt);

        return $result;

    }




    function deleteTrainingCourses($ids) {

        $tempids='('.implode(',',$ids).')';

        $sql = "SELECT `img` FROM `news`";
        $sql .= " WHERE `id` IN ".$tempids;
        $images = $this -> mDb -> getAll($sql);

        $sqll = "DELETE FROM `news_langs` ";
        $sqll.= " WHERE `news_id` IN ".$tempids;

        $this-> mDb-> query($sqll);

        $catsql = "DELETE FROM `news` ";
        $catsql.= " WHERE `id` IN ".$tempids;

        if($this-> mDb-> query($catsql)){

            if(count($images)>0){
                for ($i=0;$i<count($images);$i++){
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'news/'. $images[$i]['img'];
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                }
            }
            return true;
        }
        else{
            return false;
        }
    }






}?>