<?php

$ShopsObj = new Shops();

class Shops {

    var $mDb;
    var $mConfig;
    var $mMailer;

    function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->mMailer = new Mailer();

    }

    function convert_object_to_array($data) {

        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }


    function getSomeShops($aStart, $aLimit, $sort, $type, $searchName,$searchCatagory) {
        $sql = "SELECT b.`id`,";
        $sql .= " bl.`name`,";
        $sql .= " bl.`description`,";
        $sql .= " b.`date_added`,";
        $sql .= " b.`status`,";
        $sql .= " b.`rented`,";
        $sql .= " b.`img`,";
        $sql .= " b.`url`,";
        $sql .= " ccl.`name` as 'station_name',";
        $sql .= " u.`full_name` AS 'user_full_name'";
        $sql .= " FROM `shops` b ";
        $sql .= " LEFT JOIN `shops_langs` bl ON b.`id` = bl.`shop_id` ";
        $sql .= " LEFT JOIN `projects_langs` ccl ON b.`station_id` = ccl.`project_id` AND ccl.`lang_code` = 'ar'   ";
        $sql .= " LEFT JOIN `users` u ON u.`id` = b.`added_by` ";
        $sql .= " WHERE b.`id` > 0  AND bl.`lang_code` = 'ar'";
        $sql.= $searchName ? ' AND bl.name like "%'.$searchName.'%"' : '';
        $sql.= $searchCatagory ? " AND b.`station_id` = '{$searchCatagory}'" : "";
        $sql .= " ORDER BY b.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//	 echo $sql; die();

        $res = $this -> mDb -> getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $stmt = "SELECT  cl.`img` FROM `shops_images` cl";
            $stmt .= " WHERE cl.`shop_id` = '{$res[$i]['id']}'";
            $res[$i]['img'] = empty($this->mDb->getOne($stmt)) ? $res[$i]['img'] :$this->mDb->getOne($stmt);
        }
        return $res;

    }

    function getSearchShopsCount($sort, $type, $searchName,$searchCatagory) {
        $sql = "SELECT COUNT(bl.`id`) as 'result_count' FROM `shops_langs` bl ";
        $sql.="left join shops b on bl.shop_id = b.id  WHERE bl.`id` >
        0 AND bl.lang_code='ar' ";
            $sql.= $searchName ? ' AND bl.`name` like "%'.$searchName.'%"' : '';
        $sql.= $searchCatagory ? " AND b.`station_id` = '{$searchCatagory}'" : "";

        $sql .= " ORDER BY bl.{$sort} {$type}";
//        	 echo $sql; die();
        return $this -> mDb -> getOne($sql);
    }


//    function getSearchshopsCount($sort, $type, $searchName,$searchCatagory) {
//        $sql = "SELECT COUNT(c.`id`) as 'result_count' FROM `shops` c";
////        $sql .= " LEFT JOIN `shops_langs` cl ON c.`id` = cl.`shop_id` ";
////        $sql .= " WHERE c.`id` > 0 AND cl.`lang_code` = 'ar'";
//        $sql.= $searchCatagory ? " AND c.`station_id` = '{$searchCatagory}'" : "";
//        $sql .= $searchName ? ' AND cl.`name` like "%'.$searchName.'%"' : '';
//
//        $sql .= $sort === 'sort' ? " ORDER BY c.`sort` {$type}" : " ORDER BY {$sort} {$type}";
//
////        echo $sql; die();
//
//        return $this -> mDb -> getOne($sql);
//    }

    function getShopsCount() {
        $sql = "SELECT COUNT(`id`) as 'count' FROM `shops`";
        return $this -> mDb -> getOne($sql);
    }
    function getTrainingstations() {
        $result = array();
        $sql = "SELECT c.`id`, cl.`name`, cl.`description` FROM `stations` c";
        $sql .= " LEFT JOIN `stations_langs` cl ON c.`id` = cl.`station_id` ";
        $sql .= " WHERE  cl.`lang_code`='ar'";
//    echo $sql;
        $result = $this -> mDb -> getAll($sql);
        return $result;
    }

    function getAllStations() {
        $sql = "SELECT cu.* ,";
        $sql .= " cul.`name`";
        $sql .= " FROM `projects` cu ";
        $sql .= " LEFT JOIN `projects_langs` cul ON cu.`id` = cul.`project_id` ";
        $sql .= " WHERE cu.`id` > 0 AND cu.`status`='1'  AND cu.`project_type`='stations'  AND cul.`lang_code` = 'ar' ";
//	 echo $sql; die();
        return $this -> mDb -> getAll($sql);
    }

    function getbooksWithCatId($cat_id) {
        $sql = "SELECT bs.* ,";
        $sql .= " bkl.`name`,";
        $sql .= " ccl.`name` as 'category_name',";
        $sql .= " u.`full_name` AS 'user_full_name'";
        $sql .= " FROM `shops` bs ";
        $sql .= " LEFT JOIN `shops_langs` bkl ON bs.`id` = bkl.`shop_id` ";
        $sql .= " LEFT JOIN `stations_langs` ccl ON bs.`station_id` = ccl.`station_id`
        AND ccl.`lang_code` = 'ar'";
        $sql .= " LEFT JOIN `users` u ON u.`id` = bs.`added_by` ";
        $sql .= " WHERE bs.`id` > 0  AND bkl.`lang_code` = 'ar' AND bs.`station_id` = '{$cat_id}' ";
//         echo $sql; die();
        return $this -> mDb -> getAll($sql);
    }


    function addEditShop($request,$img,$uploadedFile) {

        $dataImagesObj = json_decode($request['filesImages']);
        $newDataImagesObj = $this->convert_object_to_array($dataImagesObj);

        $categoryLangObj = json_decode($request['langs']);
        $newcategoryLangObj = $this->convert_object_to_array($categoryLangObj);

        $langs = $newcategoryLangObj;
        $user_id = $request['user_id'];
        $station_id = $request['station_id'];
        $status = $request['status'] == 'true' ? "1" : "0";
        $rented = $request['rented'] == 'true' ? "1" : "0";
        $sort=$request['sort']?$request['sort']:'0';
        $id = $request['id'];
        $url = ($request['url'] == '' || $request['url'] == null || $request['url'] == "null" || $request['url'] == "undefined") ? '' : $request['url'];
        $res = false;


        if ($id < 1 ) {
            // Add
            $dateTime = date('Y-m-d H:i:s');

            $sql = "INSERT INTO `shops` SET ";
            $sql .= " `added_by` = '{$user_id}',";
            $sql .= " `status` = '{$status}', ";
            $sql .= " `rented` = '{$rented}', ";
            $sql .= " `station_id` = '{$station_id}', ";
            $sql .= " `date_added` = '{$dateTime}' ,";
            $sql .= " `sort` = '{$sort}',";
            if (!empty($url)){
                $sql .= " `url` = '{$url}',";
            }else {
                $sql .= " `url` = null,";
            }
            // die($img);
            $sql .= " `img` = '{$img}',";
            $sql.=" `shop_file`= '{$uploadedFile}'";
            $this -> mDb ->query($sql);
            $last_station_id = $this -> mDb ->getLastInsertId();
            foreach ($newDataImagesObj as $k => $v) {
                if ($v['img']) {
                    $stmt = "INSERT INTO `shops_images` SET ";
                    $stmt .= " `shop_id` = '{$last_station_id}', ";
                    $stmt .= " `img` = '{$v['img']}'";
                    $res = $this->mDb->query($stmt);
                }
            }
            foreach ($langs as $value) {
                $description = addslashes($value['description']);
                $name = addslashes($value['title']);
                $stmt = "INSERT INTO `shops_langs` SET ";
                $stmt .= " `shop_id` = '{$last_station_id}', ";
                $stmt .= " `lang_code` = '{$value['lang_code']}', ";
                $stmt .= " `name` = '{$name}', ";
                $stmt .= " `description` = '{$description}'";
                $res = $this -> mDb -> query($stmt);

            }
//            echo $res;
            return $res;

        }
        else
        {

            // Edit

            $check_query = "SELECT `id` FROM `shops` WHERE `id` = '{$id}'";
            $check_result = $this -> mDb -> getOne($check_query);

            if ($check_result === false) {

                return 403;

            }
            else{

                $sql = "UPDATE `shops` SET ";
                $sql .= " `added_by` = '{$user_id}', ";
                $sql .= " `sort` = '{$request['sort']}', ";
                if (!empty($url)){
                    $sql .= " `url` = '{$url}', ";
                }else {
                    $sql .= " `url` = null, ";
                }
                $sql .= " `station_id` = '{$station_id}',";
                $sql .= " `status` = '{$status}', ";
                $sql .= " `rented` = '{$rented}' ";
                if ($img) {

                    // Delete old image from the server
                    $img_query = "SELECT `img` FROM `shops` WHERE `id` = '{$id}'";
                    $img_result = $this -> mDb -> getOne($img_query);

                    $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'shops/' . $img_result;

                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }

                    $sql .= ",`img`='{$img}' ";
                }
                if ($uploadedFile != '' || $uploadedFile != null) {

                    // Delete old image from the server
                    $img_query = "SELECT `shop_file` FROM `shops` WHERE `id` = '{$id}'";
                    $img_result = $this -> mDb -> getOne($img_query);

                    $old_img = $_SERVER['DOCUMENT_ROOT'].'/' . $this->mConfig['uploads_path'] . 'shops/files' . $img_result;

                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }

                    $sql .= ",`shop_file`='{$uploadedFile}' ";
                }




                $sql .= " WHERE `id` = '{$id}'";

                // echo $sql; die();

                $this -> mDb -> query($sql);

//                foreach ($newcategoryLangObj as $key => $value) {
//
//                    $stmt = "UPDATE `shops_langs` SET";
//                    $stmt .=" `name`='{$value['category_name']}', ";
//                    $stmt .=" `description`='{$value['category_description']}' ";
//                    $stmt .=" WHERE `lang_code`='{$value['lang_code']}' AND `shop_id` = '{$station_id}'";
//                    $res = $this -> mDb -> query($stmt);
//
//                }

                foreach ($langs as $value) {
                    $description = addslashes($value['description']);
                    $name = addslashes($value['title']);
                    $stmt = " UPDATE `shops_langs` SET ";
                    $stmt .= " `name` = '{$name}', ";
                    $stmt .= " `description` = '{$description}'";
                    $stmt .=" WHERE `lang_code`='{$value['lang_code']}' AND `shop_id` = '{$id}'";

                    $res = $this -> mDb -> query($stmt);
                }
                
                
                $sqll = "DELETE FROM `shops_images` ";
                    $sqll .= " WHERE `shop_id` ='{$id}' ";
                    $this->mDb->query($sqll);

                    foreach ($newDataImagesObj as $key2 => $val2) {
                        if ($val2['img']) {
                            $stmt = "INSERT INTO `shops_images` SET ";
                            $stmt .= " `shop_id` = '{$id}', ";
                            $stmt .= " `img` = '{$val2['img']}'";
                            $res = $this->mDb->query($stmt);
                        }
                    }

                return $res;

            }
        }

    }



//$sql .= " ccl.`name` as 'station_name',";
//$sql .= " u.`full_name` AS 'user_full_name'";
//$sql .= " FROM `shops` b ";
//$sql .= " LEFT JOIN `shops_langs` bl ON b.`id` = bl.`shop_id` ";
//$sql .= " LEFT JOIN `stations_langs` ccl ON b.`station_id` = ccl.`station_id` AND ccl.`lang_code` = 'ar'   ";
//$sql .= " LEFT JOIN `users` u ON u.`id` = b.`added_by` ";
//$sql .= " WHERE b.`id` > 0  AND bl.`lang_code` = 'ar'";
    function getOneShop($id) {

        $result = array();
        $sql = "SELECT b.`id`,b.`shop_file`, b.`added_by`, b.`status`, b.`rented`,b.`station_id`, b.`sort`,b.`url`, b.`img`, ";
        $sql .= " ccl.`name` as 'station_name'";
        $sql .= " FROM `shops` b ";
        $sql .= " LEFT JOIN `projects_langs` ccl ON b.`station_id` = ccl.`project_id` AND ccl.`lang_code` = 'ar'   ";
        $sql .= " WHERE b.`id` = '{$id}'";
        $result = $this -> mDb -> getRow($sql);

        $stmt = "SELECT cl.`lang_code`, cl.`name`, cl.`description` FROM `shops_langs` cl";
        $stmt .= " WHERE cl.`shop_id` = '{$id}'";
        $result['langs'] = $this -> mDb -> getAll($stmt);
        $q = "SELECT  cl.`img`  FROM `shops_images` cl";
        $q .= " WHERE cl.`shop_id` = '{$id}'";

        $result['images'] = $this->mDb->getAll($q);

        return $result;

    }

function AllRentsCount($shop_id){
    $sql = "SELECT COUNT(`id`) as 'count' FROM `rents_requests` where `shop_id`='{$shop_id}'";
//    echo $sql;
//    die();
    return $this -> mDb -> getOne($sql);
}


    function deleteShop($ids) {

        $tempids='('.implode(',',$ids).')';

        $sql = "SELECT `img` FROM `shops`";
        $sql .= " WHERE `id` IN ".$tempids;
        $images = $this -> mDb -> getAll($sql);

        $sqll = "DELETE FROM `shops_langs` ";
        $sqll.= " WHERE `shop_id` IN ".$tempids;

        $this-> mDb-> query($sqll);

        $catsql = "DELETE FROM `shops` ";
        $catsql.= " WHERE `id` IN ".$tempids;

        if($this-> mDb-> query($catsql)){

            if(count($images)>0){
                for ($i=0;$i<count($images);$i++){
                    $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'shops/'. $images[$i]['img'];
                    if (file_exists($old_img)) {
                        @unlink($old_img);
                    }
                }
            }
            return true;
        }
        else{
            return false;
        }
    }



    function getBookByParentID($id,$type) {
        $result = array();
        $sql = "SELECT c.`id`, cl.`name`, cl.`description` FROM `stations` c";
        $sql .= " LEFT JOIN `stations_langs` cl ON c.`id` = cl.`station_id` ";
        $sql .= " WHERE c.`parent_id` = '{$id}' and cl.`lang_code`='ar' and c.`category_type`='{$type}'";
//    echo $sql;
        $result = $this -> mDb -> getAll($sql);
        return $result;

    }







}






?>
