<?php

/* * *************************************************************************
 *
 *   PROJECT: BigWish App
 *   powerd by IT PLUS Team
 *   Copyright 2020 IT Plus Inc
 *   http://it-plus.co/ *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET,POST,PUT,DELETE,OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

require_once 'init.php';

// Start Functionality
$postdata = file_get_contents("php://input");

$token  = apache_request_headers()["Authorization"];
$verify = $hs256Obj->verifyJWT('sha256', $token);

if (isset($token) && isset($verify) && $verify) { //

    //Get All Sub Features
if($_GET['action'] == 'getAllFeatures') {
    if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';
        $lang_code = $_GET['lang_code'] ? $_GET['lang_code'] : "ar";
        $start = $_GET['start'] ? $_GET['start'] : "0";
        $perpage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : "100";
        $searchName = $_GET['searchName'] ? $_GET['searchName'] : "";
        $mainFeature = $_GET['mainFeature'] ? $_GET['mainFeature'] : "";//&mainFeature=29

        $data = $NewsWebObj->getAllfeatures($start,$perpage,$lang_code, $searchName, $type, $sort, $mainFeature);
        $Data = $data?$data:'';
        // $Data = [
        //     'errors' => $data ? '' : "no data",
        //     'data' => $data ? $data : null,
        // ];
    }
}
//Get All Main Features 
if($_GET['action'] == "getMainFeatures"){
    $start         = $_GET['start'] ? $_GET['start'] : 0;
    $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 50;

    $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
    $type = $_GET['type'] ? $_GET['type'] : 'DESC';

    $lang = $_GET['lang'] ? $_GET['lang'] : 'ar';

    $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
    $data = $NewsWebObj->getMainFeatures($start, $aItemsPerPage, $sort, $lang, $type, $searchName);
    $Data = $data?$data:"";
}

// Get Features With Subfeatures
if($_GET['action'] == "getFeaturesWithSubFeatures"){

    $start         = $_GET['start'] ? $_GET['start'] : 0;
    $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 550;

    $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
    $type = $_GET['type'] ? $_GET['type'] : 'DESC';

    $lang = $_GET['lang'] ? $_GET['lang'] : 'ar';

    $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
    $data = $NewsWebObj->getFeaturesWithSubFeatures($start, $aItemsPerPage, $sort, $lang, $type, $searchName);
    $Data = [
        'errors' => $data ? '' : "no data",
        'data' => $data ? $data : null,
    ];
}

if($_GET['action'] == 'getSubFeatures') {
    
    $id = $_GET['id'] ? $_GET['id'] : "";
    // echo $id;die();
        $data = $NewsWebObj->getSubFeatures($id);
        $Data = $data?$data:null;
}
// Get One Feature With details
if($_GET['action'] == 'getOneFeaturesDetails') {

    $Req = json_decode($postdata, true);
        $lang_code = $_GET['lang_code'] ? $_GET['lang_code'] : "ar";
        $id = $Req['id'] ? $Req['id'] : "";
        $data = $NewsWebObj->getOneFeaturesDetails($id,$lang_code);
        $Data = $data?$data:null;
}

// Add Or Edit Features
if ($_GET['action'] == 'addEditFeature') {
//   print_r($_GET['img']);die();
    $operation = $_REQUEST['operation'];
    $feature_id = '';

    $temp = array();

    $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp", "webp");
    $maxsize = 1024 * 20; //kb
    // $uploadFolder = 'wethaq/api/uploads/banks';
    $uploadFolder = $Config['uploads_path'] . 'features';

    $thumbsConfig = array(
        array(
            'name' => 'medium',
            'width' => '240',
            'hight' => '250'
        ),
        array(
            'name' => 'small',
            'width' => '80',
            'hight' => '80'
        ),
    );
    
    $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);
    // print_r($_FILES);die();
    foreach($_FILES as $key => $img){
        if (isset($_FILES[$key]['name']) AND $_FILES[$key]['name'] != '') {
        
            //get file name
            $file['name'] = addslashes($_FILES[$key]["name"]);
            // get file type
            $file['type'] = $_FILES[$key]['type'];
            // get filesize in KB
            $file['size'] = $_FILES[$key]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES[$key]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES[$key]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                $upfile = $upload->Upload_File($file, $maxsize);
                //if uploagetCategoryByParentIDding successfully
                // echo $upfile;die();
                if ($upfile) {
                    $temp[$key] = $upfile['newname'];
                    // print_r ($temp[$key]);die();
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                     echo $showError[0][0];die();
                }
            }
        }
        else
        {
            $temp = null;
        }
       
    }

    $feature_id = $_REQUEST['id'];
    // return$_REQUEST['id'];

    // print_r($_REQUEST);die();
    $data = $NewsWebObj->addEditFeature($_REQUEST, $temp["img"], $temp["icon"], $temp["img_en"], $temp["icon_en"], $feature_id );
    $Data = $data?$data:""; 
}    




    //old
    if($_GET['action'] == 'getOneFeature'){
        $id = $_GET['id'];
        $lang = $_GET['lang']?$_GET['lang']:"ar";

        $featureData = $NewsWebObj->getOneFeature($id, $lang);

        $Data = $featureData ? $featureData : '';
    }
    // if ($_GET['action'] == 'getAllFeatures') {
        
    //     $start         = $_GET['start'] ? $_GET['start'] : 0;
    //     $aItemsPerPage = $_GET['aItemsPerPage'] ? $_GET['aItemsPerPage'] : 10;

    //     $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
    //     $type = $_GET['type'] ? $_GET['type'] : 'DESC';

    //     $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';

    //     $categoryData = $NewsWebObj->getAllFeatures($start, $aItemsPerPage, $sort, $type, $searchName);

    //     $Data = $categoryData ? $categoryData : '';
    // }

    if ($_GET['action'] == 'getSearchFeaturesCount') {

        $sort = $_GET['sort'] ? $_GET['sort'] : 'id';
        $type = $_GET['type'] ? $_GET['type'] : 'DESC';

        $searchName = $_GET['searchName'] ? $_GET['searchName'] : '';
        $mainFeature = $_GET['mainFeature'] ? $_GET['mainFeature'] : '';

        $categorySearchData = $NewsWebObj->getSearchFeaturesCount($sort, $type, $searchName, $mainFeature);

        $Data = $categorySearchData ? $categorySearchData : '';
    }

    if ($_GET['action'] == 'getFeaturesCount') {

        $categoryData = $NewsWebObj->getFeaturesCount();
        $Data      = $categoryData ? $categoryData : '';
    }
    if ($_GET['action'] == 'getTrainingCategories') {

        $categoryData = $NewsWebObj->getTrainingCategories();
        $Data      = $categoryData ? $categoryData : '';
    }

    if ($_POST['action'] == 'addEditNews') {

        
        $temp = array();

        $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp");
        $maxsize = 1024 * 2; //kb
        // $uploadFolder = 'wethaq/api/uploads/banks';
        $uploadFolder = $Config['uploads_path'] . 'news';

        $thumbsConfig = array(
            array(
                'name' => 'medium',
                'width' => '240',
                'hight' => '250'
            ),
            array(
                'name' => 'small',
                'width' => '80',
                'hight' => '80'
            ),
        );

        $upload = new Upload($allow_ext, $thumbsConfig, $maxsize, $uploadFolder, false);

        if (isset($_FILES['file']['name']) AND $_FILES['file']['name'] != '') {

            //get file name
            $file['name'] = addslashes($_FILES["file"]["name"]);
            // get file type
            $file['type'] = $_FILES["file"]['type'];
            // get filesize in KB
            $file['size'] = $_FILES["file"]['size'] / 1024;
            // get file tmp path
            $file['tmp'] = $_FILES["file"]['tmp_name'];
            //get file ext [to get max uploades size]
            $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
            //check if guest have selected file or not
            if ($file['name'] != '') {
                // Start Uploading File
                $upfile = $upload->Upload_File($file, $maxsize);

                //if uploading successfully
                if ($upfile) {
                    $temp['file'] = $upfile['newname'];
                } else {
                    $error = true;
                    $showError[] = $upload->showErrors();
                    $top_msg['error'][] = $showError[0][0];
                }
            }
        }
        else
        {
            $temp = null;
        }


        $categoryData = $NewsWebObj->addEditNews($_REQUEST, $temp['file']);
        $Data = $categoryData?$categoryData:'';
    }


} else {
    echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
}


if (isset($postdata) && !empty($postdata)) {

    $Req = json_decode($postdata, true);

    if (true) {//isset($token) && isset($verify) && $verify

        if ($_GET['action'] == 'getOneTrainingCourses') {

            $oneCategoryData = $NewsWebObj->getOneTrainingCourses($Req);
            $Data        = $oneCategoryData ? $oneCategoryData : '';
        }
        if ($_GET['action'] == 'getCategoryByParentID') {

            $oneCategoryData = $NewsWebObj->getCategoryByParentID($Req);
            $Data        = $oneCategoryData ? $oneCategoryData : '';
        }

        if ($_GET['action'] == 'deleteFeature') {

            $categoryData = $NewsWebObj->deleteFeature($Req);
            $Data     = $categoryData ? $categoryData : '';
        }


    }
    else {
        echo json_encode(["status" => 401, "message" => "Unauthorized Request"]);
    }

}

echo json_encode($Data);
